import { Drawer2D } from "./drawer2D";
import { Drawer3D } from "./drawer3D";
import { TriangleDrawer } from "./triangle_drawer";

export class CanvasApp{
    readonly gl: WebGL2RenderingContext;
    renderer: Drawer2D;
    trenderer : TriangleDrawer;
    r : Drawer3D;
    constructor(gl: WebGL2RenderingContext){
        this.gl = gl;
        this.renderer = new Drawer2D(gl);
        this.trenderer = new TriangleDrawer(gl);
        this.r = new Drawer3D(gl);
    }
    intialize():boolean{
        this.renderer.prepare();
        this.trenderer.prepare(this.gl);
        this.r.init();

        document.addEventListener("keydown",(e)=>{
            if(e.key == "h"){
                this.r.camera.rotateRight(Math.PI * 5 / 180.0);
            }
            if(e.key == "f"){
                this.r.camera.rotateRight(-Math.PI * 5 / 180.0)
            }
            if(e.key == "t"){
                this.r.camera.rotateUp(Math.PI * 5 / 180.0)
            }
            if(e.key == "g"){
                this.r.camera.rotateUp(-Math.PI * 5 / 180.0)
            }
            if(e.key == "d"){
                this.r.camera.pos[0] += 0.5;
            }
            if(e.key == "a"){
                this.r.camera.pos[0] -= 0.5;
            }
            if(e.key == "w"){
                this.r.camera.pos[2] += 0.5;
            }
            if(e.key == "s"){
                this.r.camera.pos[2] -= 0.5;
            }
        });

        this.gl.clearColor(0,0,0,0);
        this.gl.clearDepth(1);
        this.gl.enable(this.gl.DEPTH_TEST);
        return true;
    }
    startRun(){
        const current = new Date();
        this.loop();
        const delta = (new Date().getMilliseconds()) - current.getMilliseconds();
        const delay = (delta < 16) ? (16 - delta) : 1;
        setTimeout((()=>{
            this.startRun();
        }).bind(this),delay);
    }
    loop(){
        
    }
    startDraw(){
        this.drawScene();
    }
    drawScene(){
        this.gl.viewport(0,0,this.gl.canvas.width,this.gl.canvas.height);
        this.gl.clear(this.gl.COLOR_BUFFER_BIT|this.gl.DEPTH_BUFFER_BIT);
        //this.renderer.draw(this.gl,{});
        //this.trenderer.draw(this.gl,{});
        this.r.draw(this.gl,{});
        requestAnimationFrame(this.drawScene.bind(this));
    }
};