#version 300 es

layout(location=0) in vec3 position;
layout(location=1) in vec2 textureUV;
layout(location=2) in vec3 normal;

uniform mat4 modelMat;
uniform mat4 viewMat;
uniform mat4 projectionMat;

out vec3 fragNormal;

void main() {
  gl_Position = projectionMat * viewMat * modelMat * vec4(position,1);
  fragNormal = mat3(transpose(inverse(modelMat))) * normal;
}